﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.ChartView;

namespace wpf_ChartView_631306
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            var data = this.GetData();
            this.AddLogarithmicAxisAnnotations(data[data.Count - 1].Date);
            this.DataContext = data;

            LogarithmicAxis asd;
        }

        private void AddLogarithmicAxisAnnotations(DateTime maxValue)
        {
            var axisLabelTemplate = this.Resources["AxisLabelTemplate"] as DataTemplate;

            for (int i = 0; i <= 50; i += 5)
            {
                CartesianGridLineAnnotation lineAnnotation = new CartesianGridLineAnnotation();
                lineAnnotation.Opacity = 0.2;
                lineAnnotation.ZIndex = -300;
                lineAnnotation.Axis = this.chart.VerticalAxis;
                lineAnnotation.Value = i;
                this.chart.Annotations.Add(lineAnnotation);

                CartesianCustomAnnotation textAnnotation = new CartesianCustomAnnotation();
                textAnnotation.ClipToPlotArea = false;
                textAnnotation.HorizontalAxis = this.chart.HorizontalAxis;
                textAnnotation.VerticalAxis = this.chart.VerticalAxis;
                textAnnotation.HorizontalValue = maxValue;
                textAnnotation.VerticalValue = i;
                textAnnotation.Content = i.ToString();
                textAnnotation.ContentTemplate = axisLabelTemplate;
                this.chart.Annotations.Add(textAnnotation);
            }
        }

        private List<PlotInfo> GetData()
        {
            var data = new List<PlotInfo>();
            Random random = new Random();
            for (int i = 0; i < 100; i++)
            {
                var plotInfo = new PlotInfo();
                plotInfo.Date = new DateTime(2012, 11, 21).AddDays(i);
                plotInfo.Value = random.Next(0, 50);
                data.Add(plotInfo);
            }

            return data;
        }
    }

    public class PlotInfo
    {
        public DateTime Date { get; set; }
        public double Value { get; set; }
    }
}
